projcount = {};
player_to_monster = player_to_monster_index;


function flip(angle)
	local ang = angle - 180;
	ang = adapt(ang);
	return ang;
end

function distance_formula(x1, y1, z1, x2, y2, z2)
	return math.sqrt((x1 - x2)^2 + (y1 - y2)^2 + (z1 - z2)^2);
end

function calc_tangent(monster, projectile)
	local mx, my, mz = get_monster_position(monster);
	local angle, pitch = get_projectile_angle(projectile);
	local pp, px, py, pz = get_projectile_position(projectile);
	px = px * 1024;
	py = py * 1024;
	pz = pz * 1024;
	local dx = px - mx;
	local dy = py - my;
	local theta = math.deg(math.atan2(dy, dx));
	local f = flip(angle);
	local new_angle = theta - (f - theta);
	new_angle = adapt(new_angle);
	return new_angle;
end

function monster_to_player(monster)
	local a;
	for a=0, number_of_players()-1, 1 do
		if (player_to_monster(a) == monster) then
			return a;
		end
	end
	return nil;
end

function super_shield(player)
	local a;
	for a=0, MAXIMUM_PROJECTILES_PER_MAP-1, 1 do
		if (projectile_index_valid(a) and projcount[a] <= 2) then
			local p, x, y, z  = get_projectile_position(a);
			local yaw, pitch = get_projectile_angle(a);
			local px, py, pz = get_player_position(player);
			pz = pz + .4;
			local distance = distance_formula(x, y, z, px, py, pz);
			local monster = player_to_monster_index(player);
			if (distance <= 1 and get_projectile_owner(a) ~= monster) then
				local new_angle = calc_tangent(monster, a);
				set_projectile_angle(a, new_angle, pitch);
				set_projectile_owner(a, monster);
			end
		end
	end
end

function idle()
	local a;
	for a=0, MAXIMUM_PROJECTILES_PER_MAP-1, 1 do
		if (projectile_index_valid(a)) then
			if (not projcount[a]) then
				projcount[a] = 0;
			end
			local p, x, y, z  = get_projectile_position(a);
			local yaw, pitch = get_projectile_angle(a);
			if (projcount[a] <  math.floor(8/number_of_players()) * 10) then
				if (x < -5 or x > 3) then
					if (yaw > 180) then
						yaw = 180 + (180 - flip(yaw));
					else
						yaw = 180 - yaw;
					end
					set_projectile_angle(a, yaw, pitch);
					projcount[a] = projcount[a] + 1;
				end
				if (y > 4 or y < -4) then
					yaw = 360 - yaw;
					set_projectile_angle(a, yaw, pitch);
					projcount[a] = projcount[a] + 1;
				end
				if (z < .3 or z > 4) then
					pitch = pitch * -1;
					set_projectile_angle(a, yaw, pitch);
					projcount[a] = projcount[a] + 1;
				end
			end
		else
			projcount[a] = nil;
		end	
	end
	local zzz;
	for zzz=0, number_of_players()-1, 1 do
		if (not player_is_dead(zzz)) then super_shield(zzz); end
	end
end

function adapt(angle)
	if (angle >= 360) then
		return angle - 360;
	elseif (angle < 0) then
		return angle + 360;
	else
		return angle;
	end
end